<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.client.delegate.common.FavoriteDetails"%>
<%@ page import="com.lombardisoftware.client.persistence.common.ID" %>
<%@ page import="com.lombardisoftware.core.TeamWorksException" %>
<%@ page import="com.lombardisoftware.portal.servlet.InjectServlet" %>
<%@ page import="com.lombardisoftware.portal.struts.Constants" %>
<%@ page import="com.lombardisoftware.portal.utils.ExposedItemHelper" %>
<%@ page import="com.lombardisoftware.portal.utils.TaskInstanceUtils" %>
<%@ page import="com.lombardisoftware.portal.utils.UserAttributesHelper" %>
<%@ page import="com.lombardisoftware.psapi.data.Query" %>
<%@ page import="com.lombardisoftware.server.api.ActionPolicy" %>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.Map" %>
<%@ page import="java.math.BigDecimal" %>
<%@ page import="teamworks.SecurityUtils" %>
<%@ page import="org.apache.struts.Globals" %>
<%@ taglib prefix="tiles" uri="/WEB-INF/struts-tiles.tld"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>

<%@ include file="../contextRoot.jsp" %>

<jsp:useBean id="user" class="com.lombardisoftware.psapi.data.User" scope="session"/>

<%
    final String language = UserAttributesHelper.getLanguage();
%>

<script TYPE="text/javascript"src="<%=request.getContextPath()%>/js/toolbar.js"></script>
<script type="text/javascript" src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojo/dojo.js"
        djConfig="locale:'<%= language %>', extraLocale:'en'"></script>

<%!
    static class ActionAccess {
        private boolean initialized = false;
        private boolean canAccessActions;
        public boolean canAccess() throws TeamWorksException {
            if (!initialized) {
                canAccessActions = SecurityUtils.adHocEvent_canRun();
                initialized = true;
            }
            return canAccessActions;
        }
    }
%>
<%
    final Object bpdInstanceId = request.getAttribute("bpdInstanceId");
    Query queryObject = (Query) session.getAttribute("queryObject");

    boolean instanceMode;
    boolean taskMode;
    boolean lfoMode = false;
    boolean isInstanceDetails;
    boolean hasActions = false;
    ActionAccess actionAccess;
    boolean canChangeCriticalPath = false;
    Map startEventsMap = new HashMap();

    Cookie[] cookies = request.getCookies();
    if (cookies != null) {
        for (int i = 0; i < cookies.length; i++) {
            if (cookies[i].getName().equals("LfoVersion")) {
                lfoMode = true;
                break;
            }
        }
    }

    if (queryObject != null) {
        instanceMode = queryObject.isOrganizedByInstance();
        taskMode = !instanceMode;
    } else {
        // task details page
        instanceMode = true;
        taskMode = true;
    }


    if (request.getParameter("taskId") != null || request.getAttribute("bpdInstanceId") != null) {
        // task details page
        instanceMode = true;
        taskMode = true;
    }

    isInstanceDetails = instanceMode && taskMode;
    if (isInstanceDetails && bpdInstanceId != null) {
        startEventsMap =
                InjectServlet.getStartInjectionEvents(new BigDecimal[]{
                        new BigDecimal(bpdInstanceId.toString())}
                );
    }

    hasActions = !startEventsMap.isEmpty();

    actionAccess = new ActionAccess();

    @SuppressWarnings({"unchecked"}) List<FavoriteDetails> startableFavorites = (List<FavoriteDetails>) request.getSession().getAttribute(Constants.Session.STARTABLE_FAVORITES);
    if(startableFavorites == null) {
        startableFavorites = ExposedItemHelper.getExposedStartables();
        request.getSession().setAttribute(Constants.Session.STARTABLE_FAVORITES, startableFavorites);
    }

    if (bpdInstanceId != null) {
        canChangeCriticalPath = SecurityUtils.criticalPathCanChange(new BigDecimal((String)bpdInstanceId));
    }

    boolean criticalPathMode = request.getParameter("cpType") != null;
%>
<div id="toolbar">
<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr valign="top">
<td valign="top"><table border="0" cellspacing="0" cellpadding="0"><tr valign="top">
    <%if(!lfoMode) {%>
        <td class="button" nowrap>
        <div style="position:relative;">
        <a id="newLink" href="#"
<%
        if(isInstanceDetails && hasActions && actionAccess.canAccess()) {
%>
           title="<bean:message key="toolbar.tip.StartAdhocProcess" bundle="ProcessPortal"/>"
<%
        }
        else {
%>
           title="<bean:message key="toolbar.tip.StartNewProcess" bundle="ProcessPortal"/>"
<%
        }
%>
        >
<%
        if(isInstanceDetails && hasActions && actionAccess.canAccess()) {
%>
            <img src="images/process/adhoc_actions.gif" align="left" alt="<bean:message key="toolbar.Actions" bundle="ProcessPortal"/>" >
            <bean:message key="toolbar.Actions" bundle="ProcessPortal"/>
<%
        }
        else {
%>
            <img src="images/management/enabled/new_16x16.gif" align="left" alt="<bean:message key="toolbar.New" bundle="ProcessPortal"/>" >
            <bean:message key="toolbar.New" bundle="ProcessPortal"/>
<%
        }
%>
        <img src="images/popup.gif" style="padding:0px" alt="<bean:message key="toolbar.popup" bundle="ProcessPortal"/>" >
        </a>
<%
        if(isInstanceDetails && hasActions && actionAccess.canAccess()) {
%>
            <div id="new" class="popup" style="position:absolute; z-index:1000; background: #056DA8;">
<%
            if(!startEventsMap.isEmpty()) {
                Iterator startEvents = startEventsMap.entrySet().iterator();
                while (startEvents.hasNext()) {
                    Map.Entry startEvent = (Map.Entry) startEvents.next();
%>
                    <div class="lnk"><a href="javascript:doStartEvent('<%=bpdInstanceId%>','<%=startEvent.getKey()%>');"><%=startEvent.getValue()%></a></div>
<%
                }
            }
%>
            </div>
<%
        }
        else if(startableFavorites.size() > 0) {
%>
            <div id="new" class="popup" style="position:absolute; z-index:1000; background: #056DA8;">
<%
            for(int i = 0; i < startableFavorites.size(); i++) {
                FavoriteDetails startable = startableFavorites.get(i);
%>
                <div id="link_<%=i%>"><a href="javascript:doFavorite(<%=ID.getBigDecimal(startable.getId())%>);"><%=startable.getDisplayName()%></a></div>
<%
            }
%>
            </div>
<%
        }
        if (isInstanceDetails && hasActions && actionAccess.canAccess() || !startableFavorites.isEmpty()) {
%>
              <script type="text/javascript">

                  // add hanlder for new from favorites toolbar item
                  document.getElementById('newLink').onclick = function(e) {
                      toggleNewPopup();
                      // this event not suppose to be handled by body.onclick() handler
                      var e = e || event;
                      e.cancelBubble=true;
                  };
                   // handler for closing this popup
                  document.body.onclick = function(){
                      closeNewPopup();
                  }

                  var width = 150;
                  var newItem = document.getElementById("new");
                  var favoriteItems = newItem.getElementsByTagName("div");
                  for (var i = 0; i < favoriteItems.length; i++) {
                      var thisFavorite = favoriteItems.item(i);
                      if (width < thisFavorite.clientWidth) {
                          width = thisFavorite.clientWidth;
                      }
                  }

                  var desiredWidth = width + 15;

                  newItem.width = desiredWidth;
                  for (var i = 0; i < favoriteItems.length; i++) {
                      var thisFavorite = favoriteItems.item(i);
                      thisFavorite.width = desiredWidth;
                  }
              </script>
<%
        }
%>
    </div>
    </td>
    <td class="divider">|</td>
<%
    }

    // Toolbar buttons
    if (instanceMode) {
%>
    <td class="button">
        <span id="actionButton<%= ActionPolicy.ACTION_SUSPEND_INSTANCE %>">
            <a title="<bean:message key="toolbar.tip.SuspendInstance" bundle="ProcessPortal"/>"
                   href="javascript:performNonPopupAction('<tiles:getAsString name="prefix"/>', 'suspendInstance.do', makeInstanceIdString())"><img id="suspendIMG" src="images/management/enabled/suspend_instance_16x16.gif" align="left" alt="<bean:message key="toolbar.tip.SuspendInstance" bundle="ProcessPortal"/>" ></a>
        </span>
    </td>
    <td class="button">
        <span id="actionButton<%= ActionPolicy.ACTION_RESUME_INSTANCE %>">
            <a title="<bean:message key="toolbar.tip.ResumeSuspendedInstance" bundle="ProcessPortal"/>"
                    href="javascript:performNonPopupAction('<tiles:getAsString name="prefix"/>', 'resumeInstance.do', makeInstanceIdString())"><img id="resumeIMG" src="images/management/enabled/resume_instance_16x16.gif" alt="<bean:message key="toolbar.tip.ResumeSuspendedInstance" bundle="ProcessPortal"/>"></a>
            </span>
        <span id="actionButton<%= ActionPolicy.ACTION_ABORT_INSTANCE%>">
            <a title="<bean:message key="toolbar.tip.Terminate" bundle="ProcessPortal"/>"
                    href="javascript:performNonPopupAction('<tiles:getAsString name="prefix"/>', 'terminateInstance.do', makeInstanceIdString())"><img id="abortIMG" src="images/management/enabled/abort_instance_16x16.gif" alt="<bean:message key="toolbar.tip.Terminate" bundle="ProcessPortal"/>"></a>
        </span>
    </td>
    <td class="divider">|</td>
    <%}%>
    <%if(taskMode){%>
    <%if(!lfoMode){%>
    <td class="button">
        <span id="actionButton<%= ActionPolicy.ACTION_ASSIGN_TASK%>">
            <a title="<bean:message key="toolbar.tip.AssignTaskToMe" bundle="ProcessPortal"/>"
                href="javascript:performNonPopupAction('<tiles:getAsString name="prefix"/>', 'assignTask.do', makeTaskIdString())"><img src="images/management/enabled/assign_to_me_16x16.gif" align="left" alt="<bean:message key="toolbar.tip.AssignTaskToMe" bundle="ProcessPortal"/>" ></a>
        </span>
    </td>
    <%} // !lfoMode %> 
    <td class="button">
        <%if(!lfoMode){%>        
        <span id="actionButton<%= ActionPolicy.ACTION_REASSIGN_TASK %>">
            <a title="<bean:message key="toolbar.tip.ReassignTaskBackToRole" bundle="ProcessPortal"/>"
                   href="javascript:performNonPopupAction('<tiles:getAsString name="prefix"/>', 'reassignTask.do', makeTaskIdString())"><img id="reassign" src="images/management/enabled/reassign_to_role_16x16.gif" alt="<bean:message key="toolbar.tip.ReassignTaskBackToRole" bundle="ProcessPortal"/>"></a>
        </span>
        <%} // !lfoMode %> 
        <span id="actionButton<%= ActionPolicy.ACTION_REASSIGN_TASK_USER_ROLE%>">
            <a title="<bean:message key="toolbar.tip.ReassignTaskToUserOrRole" bundle="ProcessPortal"/>"
                   href="javascript:performPopupAction('reassignTaskUserRoleSetup.do', makeTaskIdString(), 'height=380,width=530,scrollbars=no,resizable=no')"><img src="images/management/enabled/reassign_16x16.gif" alt="<bean:message key="toolbar.tip.ReassignTaskToUserOrRole" bundle="ProcessPortal"/>"></a>
        </span>
    </td>
    <td class="divider">|</td>
    <%}%>
    <%if(instanceMode && !criticalPathMode){%>
    <td class="button">
        <span id="actionButton<%= ActionPolicy.ACTION_CHANGE_INSTANCE_DUEDATE %>">
            <a title="<bean:message key="toolbar.tip.ChangeDueDateOfInstance" bundle="ProcessPortal"/>"
                   href="javascript:performPopupAction('changeDueDateSetup.do?type=instance', makeInstanceIdString(), 'height=400,width=340,scrollbars=no,resizable=no')"><img src="images/management/enabled/change_due_date_16x16.gif" align="left" alt="<bean:message key="toolbar.tip.ChangeDueDateOfInstance" bundle="ProcessPortal"/>" ></a>
        </span>
    </td>
    <td class="divider">|</td>
    <%}%>

    <%if(canChangeCriticalPath && taskMode && !criticalPathMode){%>
    <td class="button">
        <span id="actionButton<%= ActionPolicy.ACTION_CHANGE_CRITICAL_PATH %>">
            <a title="<bean:message key="toolbar.tip.ChangeCriticalPath" bundle="ProcessPortal"/>"
                                      href="javascript:performNonPopupActionWithoutPrefix('criticalPath.do?cpType=2', makeInstanceIdString('bpdInstanceId'))"><img src="images/cpm_16x16.gif" align="left" alt="<bean:message key="toolbar.tip.ChangeCriticalPath" bundle="ProcessPortal"/>" ></a>
        </span>
    </td>
    <td class="divider">|</td>
    <%}%>

    <%if(taskMode){%>
    <td class="button">
        <span id="actionButton<%= ActionPolicy.ACTION_CHANGE_TASK_PRIORITY %>">
            <a title="<bean:message key="toolbar.tip.ChangePriorityOfTask" bundle="ProcessPortal"/>"
                   href="javascript:performPopupAction('changePrioritySetup.do', makeTaskIdString())"><img src="images/management/enabled/change_priority_16x16.gif" alt="<bean:message key="toolbar.tip.ChangePriorityOfTask" bundle="ProcessPortal"/>" ></a>
        </span>
        <span id="actionButton<%= ActionPolicy.ACTION_CHANGE_TASK_DUEDATE %>">
            <a title="<bean:message key="toolbar.tip.ChangeDueDateOfTask" bundle="ProcessPortal"/>"
                   href="javascript:performPopupAction('changeDueDateSetup.do?type=task', makeTaskIdString(),'height=400,width=340,scrollbars=no,resizable=no')"><img src="images/management/enabled/change_due_date_16x16.gif" alt="<bean:message key="toolbar.tip.ChangeDueDateOfTask" bundle="ProcessPortal"/>" ></a>
        </span>

    </td>
     <%}%>

 <%if (!lfoMode) { %>
        <%if (taskMode) {%>
            <%if (bpdInstanceId != null && !"null".equals((String) bpdInstanceId)) { %>
                <td class="button">
                    <span id="actionButton<%= ActionPolicy.ACTION_VIEW_PROCESS_DIAGRAM %>">
                   <%
                       long bpdInstanceID = Long.parseLong((String) bpdInstanceId);
                       String url = "viewProcessInstanceDiagram.do?bpdInstanceId=" + bpdInstanceID + "&isMultipleInstances=false";
                       if (criticalPathMode) {
                           url += "&cpType=1";
                       }
                   %>
                    <script type="text/javascript">
                        var diagramPopup;
                        function popUpDiagram() {
                            diagramPopup = window.open('', 'diagramPopup', 'height=600,width=800,scrollbars=no,resizable=yes');
                            if (!diagramPopup || diagramPopup.closed || !diagramPopup.tableToDiagram) {
                                window.open('<%= url %> ', 'diagramPopup', 'height=600,width=800,scrollbars=no,resizable=yes');
                            } else {
                                diagramPopup.tableToDiagram({action: "load", url: '<%= url %>'});
                                diagramPopup.focus();
                            }
                        }
                    </script>
                        <a title="<bean:message key="toolbar.tip.ShowProcessInstanceDiagram" bundle="ProcessPortal"/>"
                            href="#DIAGRAM" onclick="popUpDiagram(); return false;"><img src="images/process/enabled/bpd_16x16.gif"  alt="<bean:message key="toolbar.tip.ShowProcessInstanceDiagram" bundle="ProcessPortal"/>"></a>
                    </span>
                </td>
            <%}%>
    <%} else if (instanceMode) {%>
        <td class="button">
             <span id="actionButton<%= ActionPolicy.ACTION_VIEW_PROCESS_DIAGRAM %>">
                   <a title="<bean:message key="toolbar.tip.ShowProcessInstanceDiagram" bundle="ProcessPortal"/>"
                       href="javascript:window.open('viewProcessInstanceDiagram.do?' + makeInstanceIdString('bpdInstanceId') + '&isMultipleInstances=true','_blank','height=600,width=800,scrollbars=no,resizable=yes').focus();">
                        <img src="images/process/enabled/bpd_16x16.gif"  alt="<bean:message key="toolbar.tip.ShowProcessInstanceDiagram" bundle="ProcessPortal"/>">
                   </a>
             </span>
        </td>
    <%}%>
    <%} // !lfoMode %>
        
      <%if(instanceMode){%>
    <td class="divider">|</td>
      <%}%>

    <%-- Button for "Process Audit" page --%>
      <%if(taskMode){%>
    <td class="button">
        <%if (!lfoMode) { %>
      <%if (bpdInstanceId != null && !"null".equals((String) bpdInstanceId)) { %>
        <span id="actionButton<%= ActionPolicy.ACTION_VIEW_PROCESS_AUDIT%>">
           <%
            long bpdInstanceID=Long.parseLong((String) bpdInstanceId);
            String url = "processAudit.jsp?bpdInstanceId=" + bpdInstanceID;
            String href="javascript:window.open('" + url + "','_blank','height=600,width=800,scrollbars=yes,resizable=yes').focus();";
           %>
            <a title="<bean:message key="toolbar.tip.ShowProcessAudit" bundle="ProcessPortal"/>" href="<%= href%>">
            <img src="images/management/enabled/process_audit_16x16.gif" align="left" alt="<bean:message key="toolbar.tip.ShowProcessAudit" bundle="ProcessPortal"/>">
            </a>
        </span>
      <%}%>
        <%} // !lfoMode %>
    </td>
      <%if(instanceMode){%>
    <td class="divider">|</td>
      <%}%>
    <%}%>

    <%if(instanceMode){%>
    <td class="button">
        <span id="actionButton<%= ActionPolicy.ACTION_ADD_HELP_REQUEST%>">
            <a title="<bean:message key="toolbar.tip.RequestHelpForInstance" bundle="ProcessPortal"/>"
                href="javascript:performPopupAction('addHelpRequestSetup.do', makeInstanceIdString('bpdInstanceId'), 'resizable=yes,height=400,width=600,toolbar=no,scrollbars=auto')"
                ><img src="images/management/enabled/request_help_16x16.gif" align="left" alt="<bean:message key="toolbar.tip.RequestHelpForInstance" bundle="ProcessPortal"/>">
                 </a>
        </span>
    </td>
    <%}%>
    <%if(instanceMode){%>
    <%if (bpdInstanceId != null && !"null".equals((String) bpdInstanceId)) {
      boolean enabledAddCalendar = TaskInstanceUtils.canAddInstanceToCalendar(
    		  new BigDecimal(bpdInstanceId.toString()), user);
    %>
    <td class="divider">|</td>
    <td class="button">
        <a <%= !enabledAddCalendar ? "disabled=\"true\"" : "" %> title="<bean:message key="toolbar.tip.AddToCalendar" bundle="ProcessPortal"/>"
            <% if (enabledAddCalendar) { %>
            href="getCalendar.do?bpdInstanceId=<%=bpdInstanceId%>"
            <% } %>
            >
            <img src="images/management/<%=  enabledAddCalendar ? "enabled" : "disabled" %>/add_to_calendar_16x16.gif" align="left" alt="<bean:message key="toolbar.tip.AddToCalendar" bundle="ProcessPortal"/>" />
        </a>
    </td>
    <%}%>
    <%}else if(taskMode) {
      boolean enabledAddCalendar = (request.getParameter("taskId") != null)
          && TaskInstanceUtils.canAddTaskToCalendar(new BigDecimal(request.getParameter("taskId").toString()), user);
    %>
    <td class="divider">|</td>
    <td class="button">
        <a <%= !enabledAddCalendar ? "disabled=\"true\"" : "" %> title="<bean:message key="toolbar.tip.AddToCalendar" bundle="ProcessPortal"/>"
            <% if (enabledAddCalendar) { %>
            href="getCalendar.do?taskId=<%=request.getParameter("taskId")%>"
            <% } %>
            >
            <img src="images/management/<%=  enabledAddCalendar ? "enabled" : "disabled" %>/add_to_calendar_16x16.gif" align="left" alt="<bean:message key="toolbar.tip.AddToCalendar" bundle="ProcessPortal"/>" />
        </a>
    </td>
    <%}%>
    </tr></table></td>
    <td valign="top">
    <table border="0" cellspacing="0" cellpadding="0" width="100%">
    <tr valign="top">
    <td style="padding-left: 18px" nowrap width="100%" align="right" class="search">
        <form name="searchForm" action="freeTextSearch.do" method="GET">
            <input id="searchTextId" name="searchText" type="text" size="14">
                <a title="<bean:message key="toolbar.tip.SearchInstanceNames" bundle="ProcessPortal"/>" href="#" onClick="document.searchForm.submit(); return false;">
                    <label for="searchTextId"><bean:message key="toolbar.QuickSearch" bundle="ProcessPortal"/> </label>
                </a>
        </form>
    </td>
    </tr>
    </table>
    </td>
 </tr></table>
 
 <img src="images/spacer.gif" height="1" width="700" alt=""><br clear="all">
 </div>
