<%@ page import="java.util.Map" %>

<%@ page import="com.lombardisoftware.portal.utils.ContextRootUtils" %>
<%@ page import="com.ibm.bpm.crconfig.BPMContextRootConfigService" %>

<%
Map<String,String> contextRootMap = ContextRootUtils.getAllContextRoots();

String webAPIContextRoot = null;
String jaxWsWebApiContextRoot = null;
String processPortalContextRoot = null;
String processPortalSupportContextRoot = null;
String processPortalNotificationContextRoot = null;
String businessSpaceContextRoot = null;
String mumContextRoot = null;
String restContextRoot = null;
String webviewerContextRoot = null;
String bpmRestContextRoot = null;
String eventMgrContextRoot = null;
String processAdminContextRoot = null;
String bpmHelpContextRoot = null;
String performanceAdminContextRoot = null;
String teamworksContextRoot = null;
String bpmRestUIContextRoot = null;
String bpmAssetContextRoot = null;
String fdsServicesContextRoot = null;
String processCenterContextRoot = null;

if (contextRootMap != null && contextRootMap.size() > 0) {
	webAPIContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_WEBAPI);
	jaxWsWebApiContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_JAXWSWEBAPI);
	processPortalContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_PROCESSPORTAL);
	processPortalSupportContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_PROCESSPORTALSUPPORT);
	webviewerContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_WEBVIEWER);	
	bpmRestContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_BPMREST);
	processPortalNotificationContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_SOCIALBUSWEB);
	businessSpaceContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_BUSINESSSPACE);
	mumContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_MASHUPS_RUNTIME);
	restContextRoot = contextRootMap.get("rest.gateway.war");
	eventMgrContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_EVENTMGR);
	processAdminContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_PROCESSADMIN);
	bpmHelpContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_BPMHELP);
	performanceAdminContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_TWPERFSVR);
	teamworksContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_TEAMWORKS);
	bpmRestUIContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_BPMREST_UI);
	bpmAssetContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_ASSET);
	fdsServicesContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_FDSSERVICES);
	processCenterContextRoot = contextRootMap.get(BPMContextRootConfigService.BPM_WARNAME_REPOSITORY);
}

String contextRootPrefix = "";
if (processPortalSupportContextRoot != null) {
	String[] values = processPortalSupportContextRoot.split("/portal");
	if (values.length > 0) {
		contextRootPrefix = values[0];
	}
	// else there is no configured context root, fall on the defaults
}

//config defaults in the event of ContextRootConfigService returning null
if (webAPIContextRoot == null || webAPIContextRoot == "NULL") {
	webAPIContextRoot = contextRootPrefix +"/webapi";
}
if (jaxWsWebApiContextRoot == null || jaxWsWebApiContextRoot == "NULL") {
	jaxWsWebApiContextRoot = contextRootPrefix +"/bpmjaxws";
}
if (processPortalContextRoot == null || processPortalContextRoot == "NULL") {
	processPortalContextRoot = contextRootPrefix +"/ProcessPortal";
}
if (processPortalSupportContextRoot == null || processPortalSupportContextRoot == "NULL") {
	processPortalSupportContextRoot = contextRootPrefix +"/portal";
}
if (processPortalNotificationContextRoot == null || processPortalNotificationContextRoot == "NULL") {
	processPortalNotificationContextRoot = contextRootPrefix +"/ProcessPortal/notification";
}
if (businessSpaceContextRoot == null || businessSpaceContextRoot == "NULL") {
	businessSpaceContextRoot = contextRootPrefix +"/BusinessSpace";
}
if (mumContextRoot == null || mumContextRoot == "NULL") {
	mumContextRoot = contextRootPrefix +"/mum";
}
if (restContextRoot == null || restContextRoot == "NULL") {
	restContextRoot = contextRootPrefix +"/rest";
}
if (webviewerContextRoot == null || webviewerContextRoot == "NULL") {
	webviewerContextRoot = contextRootPrefix +"/WebViewer";
}
if (bpmRestContextRoot == null || bpmRestContextRoot == "NULL") {
	bpmRestContextRoot = contextRootPrefix +"/rest/bpm/wle";
}
if (eventMgrContextRoot == null || eventMgrContextRoot == "NULL") {
	eventMgrContextRoot = contextRootPrefix +"/eventmgr";
}
if (processAdminContextRoot == null || processAdminContextRoot == "NULL") {
	processAdminContextRoot = contextRootPrefix +"/ProcessAdmin";
}
if (bpmHelpContextRoot == null || bpmHelpContextRoot == "NULL") {
	bpmHelpContextRoot = contextRootPrefix +"/BPMHelp";
}
if (performanceAdminContextRoot == null || performanceAdminContextRoot == "NULL") {
	performanceAdminContextRoot = contextRootPrefix +"/PerformanceAdmin";
}
if (bpmRestUIContextRoot == null || bpmRestUIContextRoot == "NULL") {
	bpmRestUIContextRoot = contextRootPrefix +"/bpmrest-ui";
}
if (bpmAssetContextRoot == null || bpmAssetContextRoot == "NULL") {
	bpmAssetContextRoot = contextRootPrefix +"/bpmasset";
}
if (fdsServicesContextRoot == null || fdsServicesContextRoot == "NULL") {
	fdsServicesContextRoot = contextRootPrefix +"/bpm/fds";
}
if (processCenterContextRoot == null || processCenterContextRoot == "NULL") {
}
%>

<script type="text/javascript">
window.contextRootObject = {
	processPortal: "<%= processPortalContextRoot %>",
	processPortalSupport: "<%= processPortalSupportContextRoot %>",
	processPortalNotification: "<%= processPortalNotificationContextRoot %>",
	businessSpace: "<%= businessSpaceContextRoot %>",
	mum: "<%= mumContextRoot %>",
	rest: "<%= restContextRoot %>",
	webviewer: "<%= webviewerContextRoot %>",
	bpmRest: "<%= bpmRestContextRoot %>",
	webAPI: "<%= webAPIContextRoot %>",
	bpmjaxws: "<%= jaxWsWebApiContextRoot %>",
	eventMgr: "<%= eventMgrContextRoot %>",
	processAdmin: "<%= processAdminContextRoot %>",
	bpmHelp: "<%= bpmHelpContextRoot %>",
	performanceAdmin: "<%= performanceAdminContextRoot %>",
	teamworks: "<%= teamworksContextRoot %>",
	bpmRestUI: "<%= bpmRestUIContextRoot %>",
	bpmAsset: "<%= bpmAssetContextRoot %>",
	fdsServices: "<%= fdsServicesContextRoot %>",
	processCenter: "<%= processCenterContextRoot %>"
};
</script>