<%@ page language="java" contentType="image/png"%>
<%@ page trimDirectiveWhitespaces="true" %>
<%@ page import="com.lombardisoftware.portal.utils.BPDToSVG,
                 java.math.BigDecimal,
                 com.lombardisoftware.org.apache.batik.transcoder.TranscoderOutput,
                 java.io.File,
                 com.lombardisoftware.org.apache.batik.transcoder.image.PNGTranscoder,
                 com.lombardisoftware.org.apache.batik.transcoder.image.ImageTranscoder,
                 com.lombardisoftware.org.apache.batik.transcoder.TranscoderInput,
                 java.io.StringReader,
                 java.net.URL,
                 com.lombardisoftware.data.criticalpath.CPPathData,
                 com.lombardisoftware.client.persistence.common.ID" %>
<%
    BigDecimal instanceId = new BigDecimal(request.getParameter("bpdInstanceId"));
    String bpdIdStr = request.getParameter("bpdId");
    
    // Trim path component.
    int pathDelimiter = bpdIdStr.lastIndexOf("/");
    if (pathDelimiter >= 0) {
        bpdIdStr = bpdIdStr.substring(pathDelimiter + 1);
    }
    
    String parentGUID = request.getParameter("parentId");
    String cpTypeString = request.getParameter("cpType");
    CPPathData cpData = (CPPathData) request.getSession().getAttribute("criticalPath");
    String svg;
    if (cpData != null && cpTypeString != null) {
	    svg = BPDToSVG.bpdInstanceToSVG(instanceId, bpdIdStr == null? null: ID.fromExternalString(bpdIdStr), parentGUID, cpData);
    } else {
	    svg = BPDToSVG.bpdInstanceToSVG(instanceId, bpdIdStr == null? null: ID.fromExternalString(bpdIdStr));
    }

    PNGTranscoder t = new PNGTranscoder();
    // custom tags are converted during onLoad so we need it.
    t.addTranscodingHint(ImageTranscoder.KEY_EXECUTE_ONLOAD, Boolean.TRUE);
    // for now just re-parse the SVG string
    TranscoderInput input = new TranscoderInput(new StringReader(svg));
    // set the URI to point to the internal URL of this JSP page, since this is what .JS and image
    // files in the SVG a relative to.
    URL url = getServletConfig().getServletContext().getResource("/jsp/");
    // NOTE:
    // WebLogic gives us a URL of the form zip:/path/foo.war!/jsp/
    // This however does not work for Batik, so instead we convert this to
    // jar:file:/path/foo.war!/jsp/
    // which does work.
    String urlString = url.toString();
    if (urlString.startsWith("zip:")) {
        urlString = "jar:file:" + urlString.substring(4);
    }
    // WebLogic does not include a trailing / for an exploded WAR
    if (!urlString.endsWith("/")) {
        urlString = urlString + "/";
    }
    // Batik accept file protocol path only in format file:/some path, not file:some path
    if (urlString.startsWith("file:") && urlString.charAt("file:".length()) != '/') {
        urlString = new StringBuffer(urlString).insert("file:".length(), '/').toString();
    }
    input.setURI(urlString);
    // output must be binary stream
    TranscoderOutput output = new TranscoderOutput(response.getOutputStream());
    // do the work
    t.transcode(input, output);
%>
