<%@ page language="java" pageEncoding="UTF-8" contentType="text/javascript; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.core.config.TWConfiguration" %>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%
	// set cache control for 1 week
	response.setHeader("Cache-Control", "max-age=604800");
%>
/**
 * The core JavaScript module providing facilities for loading of other modules.
 *
 * @module core
 */

//////////////////////////////////////////
// Core
//////////////////////////////////////////

// Define "tw" namespace
var tw = {};

// Define "tw.js" namespace
tw.js = {
	version: "1.0",
	baseUrl: "<%=request.getContextPath()%>"
};

/**
 * @type {Array}
 */
tw.js.loadedModules = {};

/**
 * Return XML HTTP Transport object provided by environment.
 */
tw.js.getXMLHttpTransport = function() {
	var result = null;
	var methods = [
      function() {return new XMLHttpRequest()},
      function() {return new ActiveXObject('Msxml2.XMLHTTP')},
      function() {return new ActiveXObject('Microsoft.XMLHTTP')}
    ];
    for(var i = 0; i < methods.length; i++) {
    	try{
    		result = methods[i]();
    		break;
    	} catch (e) {}	
    }
    return result;
}

/**
 * @param {String} path
 * @return {String}
 */
tw.js.pathToUrl = function(path) {
	var baseUrl = tw.js.baseUrl;
	if (baseUrl.lastIndexOf("/") != baseUrl.length - 1) {
		baseUrl += "/";
	}
	return baseUrl + path;	
}

/**
 * @param {String} path
 * @param {float} version
 */
tw.js.module = function(path, version) {
	tw.js.loadedModules[path] = tw.js.loadedModules[path] ? Math.max(tw.js.loadedModules[path], version) : version;
}

/**
 * Load and execute script using the given path.
 * Unlike loadModule() method, the loadScript() method doesn't affect
 * loaded modules registry. 
 * 
 * @param {String} path
 * 
 * @see tw.js.loadModule()
 */
tw.js.loadScript = function(path, failOnError) {
	var transport = tw.js.getXMLHttpTransport();
	var url = tw.js.pathToUrl(path);

	transport.open('GET', url, false);
	transport.send(null);
	
	if (transport.readyState == 4) {
		if (transport.status == 200) {
			var code = transport.responseText;
			if (code != undefined && code.length != 0) {
				if (typeof execScript != 'undefined') {
					execScript(code);
				} else if (typeof eval.call != 'undefined') {
					eval.call(window, code);
				} else {
					eval(code);
				};
				return true;
			}
		} else if (failOnError) {
			alert("IBM BPM Portal: JavaScript module couldn't be loaded - " + url);
		}  
	}

	return false;
}

/**
 * Load and execute script-library using the given path and version (optional).
 * Updates loaded modules registry to prevent repeating loading.
 * 
 * @param {String} path
 * @param {float} version
 */
tw.js.loadModule = function(path, version) {
	version = version || 1.0;
	if(tw.js.loadedModules[path] && tw.js.loadedModules[path] >= version) {
		return false;
	}
	var loaded = tw.js.loadScript(path, true);
	if (loaded) {
		tw.js.module(path, version);
		return true;
	}
	return false;
}