<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="tiles" uri="/WEB-INF/struts-tiles.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ page import="java.util.Map"%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>
<%@ page import="com.lombardisoftware.portal.utils.UserAttributesHelper"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<%@ include file="../contextRoot.jsp" %>

<% Map<String, String> attrData = UserAttributesHelper.getUserAttributes(); %>

<html>

<head>
    <title><bean:message key="main.message.title" bundle="ProcessPortal"/></title>
    <meta http-equiv="X-UA-Compatible" content="IE=8" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <LINK REL="stylesheet" HREF="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dijit/themes/soria/soria.css" TYPE="text/css">
	<LINK REL="stylesheet" HREF="<%= teamworksContextRoot %>/html/common/smallcal.css" TYPE="text/css">

    <link rel="stylesheet" type="text/css" href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/application.css" media="screen, projection" />
	
	<script type="text/javascript">
	//Ensures timezone cookie is set for PMR 93944
	function SetTimezoneCookie() {
		var theCookie = "ibm.bpm.timezoneOffset="+escape(new Date().getTimezoneOffset())+"; path=/; ";
		document.cookie = theCookie+document.cookie;
	}
	function ReadTimezoneCookie() {
		var theCookie=""+document.cookie;
		var ind=theCookie.indexOf("ibm.bpm.timezoneOffset");
		if (ind==-1) return "";
		var ind1=theCookie.indexOf(';',ind);
		if (ind1==-1) ind1=theCookie.length;
		return unescape(theCookie.substring(ind+"ibm.bpm.timezoneOffset".length+1,ind1));
	}
	try {
		var theCookie = ReadTimezoneCookie();
		if(theCookie == null || theCookie == "") {
			SetTimezoneCookie();
		}
		var timezoneOffset = parseInt(theCookie);
		if(timezoneOffset == null || isNaN(timezoneOffset)) {
			SetTimezoneCookie();
		}
	} catch(ex) {
		SetTimezoneCookie();
	}
	</script>
	
    <script type="text/javascript" src="<%=request.getContextPath()%>/jsp/js/core.jsp"></script>
    <script type="text/javascript" src="<%=request.getContextPath()%>/js/main.js"></script>
    <script type="text/javascript" src="<%=request.getContextPath()%>/jsp/js/messages.jsp"></script>    
    <script type="text/javascript">
		//Added for cross-site scripting purposes.
		function updateIframeHeight() {
			var D = document;
			var firstHeight= Math.max(
				Math.max(D.body.scrollHeight, D.documentElement.scrollHeight),
				Math.max(D.body.offsetHeight, D.documentElement.offsetHeight),
				Math.max(D.body.clientHeight, D.documentElement.clientHeight)
			);
			var height = (parseInt(firstHeight) + 1);
			var msgBody = '{"resizeDashboardIframe":'+height+'}';
			if (window.parent) {
				try  {
			window.parent.postMessage(msgBody, "*");
				} catch(e) {
					var messObj={origin: window.location.protocol + "//" + window.location.host,
											data: msgBody, 
											source: window};
					window.parent.onMessage(messObj);
					
				}
			}
		}
	</script>

<%-- Normally contained in commonTiles/Navigation.jsp --%>
<logic:present cookie="DisableNavigation">
<script type="text/javascript">

function SetCookie(cookieName,cookieValue) {
    document.cookie = cookieName+"="+escape(cookieValue);
}

function ReadCookie(cookieName) {

    var theCookie=""+document.cookie;
    var ind=theCookie.indexOf(cookieName);
    if (ind==-1 || cookieName=="") return "";
    var ind1=theCookie.indexOf(';',ind);
    if (ind1==-1) ind1=theCookie.length;
    return unescape(theCookie.substring(ind+cookieName.length+1,ind1));
}

</script>
</logic:present>
</head>

<% if(BidiUtils.isBidi(attrData)) { %>
    <body onload="pageLoad();updateIframeHeight();" class="soria dijitRtl" dir="rtl">
<% } else { %>
    <body onload="pageLoad();updateIframeHeight();" class="soria">
<% } %>

<logic:present cookie="DisableNavigation">
    <table  cellspacing="0" cellpadding="0" border="0" id="layout" role="presentation">
        <tr valign="top">
            <td id="content" nowrap>
                <%--<tiles:get name="body-heading"/>--%>
                <tiles:get name="toolbar"/>
                <tiles:get name="body-content"/>
            </td>
        </tr>
        <tr>
    	    <td id="content-bottom">
                <div class="left"></div>
                <div class="right"></div>   	    
    	    </td>
        </tr>
    </table>
</logic:present>
<logic:notPresent cookie="DisableNavigation">
<%-- <tiles:get name="header"/> --%>
<table  cellspacing="0" cellpadding="0" border="0" id="layout" role="presentation">
    <tr valign="top">
        <td id="content">
            <%--<tiles:get name="body-heading"/>--%>
            <tiles:get name="toolbar"/>
            <tiles:get name="body-content"/>
        </td>
    </tr>
</table>
</logic:notPresent>
</body>

</html>
