<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="com.lombardisoftware.client.delegate.HistoricalDataRetrievalServiceDelegateFactory" %>
<%@ page import="com.lombardisoftware.client.delegate.HistoricalDataRetrievalServiceDelegate" %>
<%@ page import="java.math.BigDecimal" %>
<%@ page import="com.lombardisoftware.analysis.DataChangeRetrievalParameters" %>
<%@ page import="com.lombardisoftware.analysis.HistoricalDataType" %>
<%@ page import="com.lombardisoftware.psapi.data.BPDInstance" %>
<%@ page import="com.lombardisoftware.portal.helpers.SearchAPIHelper" %>
<%@ page import="com.lombardisoftware.portal.utils.MessagesHelper" %>
<%@ page import="com.lombardisoftware.core.TeamWorksException" %>
<%@ page import="java.util.*" %>
<%@ page import="com.lombardisoftware.analysis.data.DataChangeRecord" %>
<%@ page import="java.text.DateFormat" %>
<%@ page import="com.lombardisoftware.client.DateFormatUtils"%>
<%@ page import="java.text.NumberFormat" %>
<%@ page import="java.text.DecimalFormat" %>
<%@ page import="com.lombardisoftware.portal.utils.UserAttributesHelper"%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>

<script type="text/javascript">
    function moveFocusToBody() {
        var b = document.getElementById("body");
        if (b) {
            b.focus();//a11y
        }
    }

    function manageFocus(event) {
         if (event.keyCode == "9" ){//TAB
             moveFocusToBody();
         }
    }
</script>

<%
    Map<String, String> attrData = UserAttributesHelper.getUserAttributes();
%>
<%!

    private static class Formatter {
        
        public static String formatValue(Object value, Map<String, String> attrData) throws Exception{
            if (value == null) {
                return ""; // Do not show null to end users
            }
            if (value instanceof BigDecimal) {
                return trimDecimalZeros(value.toString());
            } else if (value instanceof Date) {
                return BidiUtils.getDateTimeFormat(attrData).format(value);
            } else if (value instanceof String) {
                return (String) value;
            } else {
                return value.toString();
            }
        }
        
        public static String trimDecimalZeros(String decimalValue) {
            if(decimalValue.indexOf(".") == -1) { // TODO i18n this
                return decimalValue; 
            }
            int trimIndex = decimalValue.length() - 1;
            for(int i = trimIndex; i > 0; i--) {
                if(decimalValue.charAt(i) == '.') {
                    trimIndex--;
                    break;
                }
                if(decimalValue.charAt(i) != '0') {
                    break;
                }
                trimIndex--;
            }
            return decimalValue.substring(0, trimIndex + 1);
        }
    }
%>
<%
    final BigDecimal bpdInstanceId = new BigDecimal(request.getParameter("bpdInstanceId"));
    if (bpdInstanceId == null)
        throw new TeamWorksException("Could not find 'bpdInstance' parameter in the request'");

    final BPDInstance bpdInstance = SearchAPIHelper.getInstance().findBPDInstanceById(bpdInstanceId);
    DataChangeRetrievalParameters dcParams = new DataChangeRetrievalParameters(bpdInstanceId);
    final HistoricalDataRetrievalServiceDelegate delegate = HistoricalDataRetrievalServiceDelegateFactory.getInstance().newInstance();
    String errorMessage = null;

    Map historyData = null;

    try {
        historyData = new TreeMap(delegate.getDataChangeHistory(dcParams));
    } catch (Exception e) {
        errorMessage = e.getMessage();
    }
    if(historyData == null) {
        errorMessage = MessagesHelper.getMessage(application, request, "processAudit.HistoricalData.NotAvailable", "ProcessPortal");
    }
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <title><bean:message key="processAudit.Title" bundle="ProcessPortal"/></title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <link rel="stylesheet" type="text/css"
          href="<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/application.css"
          media="screen, projection"/>
          
<script type="text/javascript">
	function selectVar(id){
		select = document.getElementById(id);
		option = select.options[select.selectedIndex];
		displayNone = option.id == "__displayNone";
		displayAll = option.id == "__displayAll";
		tableId = "tableForVar_" + option.id;
		
		vars = document.getElementsByTagName("tr");
		for(var i = 0; i < vars.length; i++) {
			if(vars[i].id.length > 12 && vars[i].id.substring(0, 12) == "tableForVar_") {
				if(displayNone) {
			    vars[i].style.display = "none";
			  } else if(displayAll) {
			  	vars[i].style.display = "";
			  }	else if(vars[i].id == tableId) {
			    vars[i].style.display = "";
			  }	else {
			    vars[i].style.display = "none";
			  }		  
			}	
		}
	}
</script>
</head>

<% if(BidiUtils.isBidi(attrData)) { %>
    <body onload="moveFocusToBody()" dir="rtl" class="dijitRtl">
<% } else { %>
    <body onload="moveFocusToBody()" >
<% } %>

<div role="form" aria-label="<bean:message key="processAudit.Title" bundle="ProcessPortal"/>">

<table class="fillWindowLayout" cellspacing="0" cellpadding="0" border="0" height="100%" style="width:99%;height:99%" id="layout" role="presentation">
<tr valign="top">
<td align="<%=BidiUtils.getalignment(attrData,"left")%>" id="content" nowrap>
<div class="heading">
    <div class="heading-right"></div>
    <h1 id="diagramTitle"><%=bpdInstance.getName()%></h1>
</div>

<div class="body" id="body" tabindex="0" role="form" aria-label="<bean:message key="processAudit.Title" bundle="ProcessPortal"/>">

<table class="content-table" role="presentation">
<thead>
    <tr>
        <th colspan="6" role="presentation"><p style="<%=BidiUtils.getalignment(attrData,"float:left")%>"><label for="varNames"><%= MessagesHelper.getMessage(application, request, "processAudit.BusinessVariables.Title", "ProcessPortal") %></label></p>
		&nbsp;&nbsp;
	    <select id="varNames" name="varNames" onChange="selectVar(this.id);return false;" style="<%=BidiUtils.getalignment(attrData,"float:right")%>">                                                 
	    <option value="Select Variable" id="__displayNone"><%= MessagesHelper.getMessage(application, request, "processAudit.BusinessVariables.SelectVariable", "ProcessPortal") %></option>
	    <option value="Show All" id="__displayAll"><%= MessagesHelper.getMessage(application, request, "processAudit.BusinessVariables.ShowAll", "ProcessPortal") %></option>
		<%
	    if(errorMessage == null) {
          Set historyDataKeySet0 = historyData.keySet();
          Iterator variableNamesIter0 = historyDataKeySet0.iterator();
          while (variableNamesIter0.hasNext()) {
              String variableName = (String) variableNamesIter0.next();
              // WLE-2771 Need to filter out NODE_ID as well
              if ((variableName.equals("STEP")) || (variableName.equals("NODE_ID"))) {
                  continue;
              }
	            %><option value="<%=variableName %>" id="<%=variableName%>"><%=variableName %></option><%
          }
	    }
		%>
		</select>
        </th>
    </tr>
</thead>
</table>
<table class="audit-history content-table" style="margin-top:0px;" summary="<bean:message key="processAudit.Title" bundle="ProcessPortal"/>" tabindex="0" onkeypress="manageFocus(event)">
        <thead>
	    <tr>
	        <th id="variableName" scope="col" width="14%"><%= MessagesHelper.getMessage(application, request, "processAudit.BusinessVariables.ContentTable.VariableName", "ProcessPortal") %></td>
	        <th id="who" scope="col" width="14%"><%= MessagesHelper.getMessage(application, request, "processAudit.BusinessVariables.ContentTable.Who", "ProcessPortal") %></td>
	        <th id="when" scope="col" width="14%"><%= MessagesHelper.getMessage(application, request, "processAudit.BusinessVariables.ContentTable.When", "ProcessPortal") %></td>
	        <th id="oldValue" scope="col" width="14%"><%= MessagesHelper.getMessage(application, request, "processAudit.BusinessVariables.ContentTable.OldValue", "ProcessPortal") %></td>
	        <th id="newValue" scope="col" width="14%"><%= MessagesHelper.getMessage(application, request, "processAudit.BusinessVariables.ContentTable.NewValue", "ProcessPortal") %></td>
	        <th id="step" scope="col" width="14%"><%= MessagesHelper.getMessage(application, request, "processAudit.BusinessVariables.ContentTable.Step", "ProcessPortal") %></td>
	    </tr>
		</thead>
        <tbody>
	
<% if (errorMessage != null) { %>
	<%=errorMessage%>
<%
} else {
    Set historyDataKeySet = historyData.keySet();
    Iterator variableNamesIter = historyDataKeySet.iterator();
    // Drawing section of rows for every variable
    while (variableNamesIter.hasNext()) {
        String variableName = (String) variableNamesIter.next();
        // WLE-2771 Need to filter out NODE_ID as well
        if ((variableName.equals("STEP")) || (variableName.equals("NODE_ID"))) {
        	continue;
        }
        Collection variableChanges = (Collection) historyData.get(variableName);
        Iterator variableChangesIter = variableChanges.iterator();
        boolean isFirstRecort = true;
        // Drawing row for every variable value change record
        %>
        <%
        while (variableChangesIter.hasNext()) {
            DataChangeRecord variableChangeRecord = (DataChangeRecord) variableChangesIter.next();

            String oldValFormatted = Formatter.formatValue(variableChangeRecord.getOldValue(), attrData);
            String newValFormatted = Formatter.formatValue(variableChangeRecord.getNewValue(), attrData);

            if (!oldValFormatted.equals(newValFormatted)) {
		%><tr class="content-table" id="tableForVar_<%=variableName%>" style="display:none;">
            <td headers="variableName" width="14%" align="<%=BidiUtils.getalignment(attrData,"left")%>"><%=variableName%></td>
            <td headers="who" width="14%">
				<%if(variableChangeRecord.getUserName() != null) {%>
					<%=variableChangeRecord.getUserName()%>
		      	<%} else {%>
		      		<%= MessagesHelper.getMessage(application, request, "processAudit.BusinessVariables.ContentTable.Who.System", "ProcessPortal") %>
		      	<%}
		    %></td>
		    <td headers="when" width="14%"><%=Formatter.formatValue(variableChangeRecord.getChangeDate(), attrData)%></td>
		    <td headers="oldValue" width="14%"><%=Formatter.formatValue(variableChangeRecord.getOldValue(), attrData)%></td>
		    <td headers="newValue" width="14%"><%=Formatter.formatValue(variableChangeRecord.getNewValue(), attrData)%></td>
		    <td headers="step" width="14%"><%=variableChangeRecord.getStepName()%></td>
		</tr><%
            }
        }
        %><%
    }
}
%>
</tbody></table>
</div></td></tr>

<tr valign="top">
    <td>
        <div id="content-bottom">
            <div class="left"></div>
            <div class="right"></div>
        </div>
    </td>
</tr>
</table>
</div>
</body>
</html>
