<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib prefix="tiles" uri="/WEB-INF/struts-tiles.tld"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>

<%@ include file="../contextRoot.jsp" %>

<tiles:insert page="NewSearch.jsp" flush="true"/>

<script type="text/javascript">

  function hideSearchIndicator() {
    dojo.style("searchIndicator", "display", "none");
    dojo.style("searchResultsContent", "display", "block");
  }

  function showSearchIndicator() {
    dojo.style("searchResultsContent", "display", "none");
    dojo.style("searchIndicator", "display", "block");
  }

  function showSearchResultsContent(content) {
    var contentElem = document.getElementById("searchResultsContent");
    contentElem.innerHTML = content;
  }

  function showSearchProcessingError(error) {
    var contentElem = document.getElementById("searchResultsContent");
    contentElem.innerHTML = error;
  }

  function setSearchControlsEnabled(enabled) {
    var searchOrganizationButton = document.getElementById("searchOrganizationButton");
    var searchBuilderButton = document.getElementById("searchBuilderButton");
    searchBuilderButton.disabled = !enabled;
    searchOrganizationButton.disabled = !enabled;
  }

  function executeSearch() {
  try {
    var searchUrl = "<%= request.getContextPath() %>/jsp/tiles/AdvancedSearchResultsContent.jsp";
    dojo.xhrGet( {
      url: searchUrl,
      handleAs: "text",
      preventCache: true,
      load: function(responseObject, ioArgs) {
        hideSearchIndicator();
        showSearchResultsContent(responseObject);
        setSearchControlsEnabled(true);
        dojo.addOnLoad(handleBidi);
      },
      error: function(error, ioArgs) {
        hideSearchIndicator();
        if (ioArgs.xhr.status != 0) {
          showSearchProcessingError(error);
        }
        setSearchControlsEnabled(true);
        }
      });
    } catch (err) {
       hideSearchIndicator();
       showSearchProcessingError(err);
    }
  }

 function executeSearchOnLoad() {
   showSearchIndicator();
   setSearchControlsEnabled(false);
   executeSearch();
 }

</script>

<div id="searchIndicator" class="body">
  <table class="content-table-no-lines">
   <tbody>
     <tr>
       <td align="center"><img src="<%= processPortalSupportContextRoot %>/js/dojo/1.6.1/dojox/image/resources/images/loading.gif" />
       <br><bean:message key="advancedSearchResults.searchIndicator.message" bundle="ProcessPortal"/></td>
     </tr>
   </tbody>
  </table>
</div>

<div id="searchResultsContent" class="body">
</div>

<script type="text/javascript">
  onSelectionChange();
  executeSearchOnLoad();
</script>
