<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="org.apache.struts.Globals,
    org.apache.struts.action.ActionErrors,
    org.apache.struts.action.ActionMessages,
    org.apache.struts.action.ActionMessage,
    com.lombardisoftware.psapi.data.Query,
    com.lombardisoftware.client.delegate.ProcessSearchAPIDelegate,
    com.lombardisoftware.portal.utils.MessagesHelper,
    com.lombardisoftware.portal.utils.SearchHelper,
    com.lombardisoftware.client.delegate.AuthorizationAPIDelegateFactory,
    java.util.*,
    java.text.MessageFormat,
    com.ibm.icu.text.DateFormat,
    com.ibm.icu.text.NumberFormat,
    com.lombardisoftware.client.DateFormatUtils,
    com.lombardisoftware.core.*,
    com.lombardisoftware.core.config.*,
    com.lombardisoftware.servlet.util.ServletStrings,
    com.lombardisoftware.psapi.data.SearchData,
    com.lombardisoftware.portal.utils.TaskInstanceUtils,
    com.lombardisoftware.portal.utils.BidiUtils
"%>

<%@ include file="../contextRoot.jsp" %>

<%@ taglib prefix="tiles" uri="/WEB-INF/struts-tiles.tld"%>
<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>
<jsp:useBean id="queryObject" class="com.lombardisoftware.psapi.data.Query" scope="session" />
<jsp:useBean id="user" class="com.lombardisoftware.psapi.data.User" scope="session"/>

<logic:messagesPresent>
    <html:messages id="msg" header="errors.header" footer="errors.footer" bundle="ProcessPortal">
        <li><bean:write name="msg" bundle="ProcessPortal"/></li>
    </html:messages>
</logic:messagesPresent>

<%
    long time = -1L;
    try {
        long startTime = System.currentTimeMillis();
        SearchData searchData = SearchHelper.executeSearch(queryObject, user);
        long endTime = System.currentTimeMillis();
        time = endTime - startTime;
        request.setAttribute("searchData", searchData);
    } catch (Exception ex) {
        ActionErrors errors = new ActionErrors();
        errors.add("searchError", new ActionMessage(ex.getMessage(), false));
        request.setAttribute(Globals.ERROR_KEY, errors);
    }
%>

<logic:messagesPresent property="searchError">
   <pre><html:messages id="searchError"><bean:write name="searchError"/></html:messages></pre>
</logic:messagesPresent>

<%
    // this used to be a <jsp:useBean>, but then WAS generates code that expects the class to have a no-arg constructor
    boolean isUserInputEscaped = TWConfiguration.getInstance().getServer().isEscapeUserInput();
    UserPreference userPreference = (UserPreference)session.getAttribute(UserPreference.SESSION_KEY);
    java.text.DateFormat df = (java.text.DateFormat) request.getSession().getAttribute(ServletStrings.SESSION_DATEFORMAT_KEY);
    Query.DisplayParams displayParams = new Query.DisplayParams(df);
    SearchData searchData = (SearchData) request.getAttribute("searchData");
    if (searchData == null) {
        searchData = SearchHelper.createEmptySearchData();
    }
    NumberFormat integerFormat = null;
    NumberFormat decimalFormat = null;
    DateFormat dateTimeFormat = null;
%>

<table class="content-table">
<thead>
    <tr><th colspan="<%= queryObject.getColumnCount() + 2 %>">
          <p style="float:left">
              <%if (queryObject.isOrganizedByInstance()){ %>
                  <bean:message key="advancedSearchResults.bpdInstancesTable.title" bundle="ProcessPortal"/>
              <%} else {%>
                  <bean:message key="advancedSearchResults.tasksTable.title" bundle="ProcessPortal"/>
              <%}%>
          </p>
    </th></tr>

    <tr>
        <td>&nbsp;</td>
<%
int rowNumber = 1;
int instanceStatusColumnNumber=-1;
int priorityColumnNumber=-1;
for (ListIterator columns = queryObject.columnIterator(); columns.hasNext();) {
    Query.Column column = (Query.Column) columns.next();
    String columnDisplayName = column.getName();
    if(columnDisplayName.equals("instanceStatus")){
        instanceStatusColumnNumber = rowNumber;
    }
    if(columnDisplayName.equals("taskPriority")){
        priorityColumnNumber = rowNumber;
    }
    if (column.isBusinessData()) {
            columnDisplayName = ((Query.BusinessDataColumn) column).getDisplayName(displayParams);
    }
    if (column.isFirstSortColumn()) {
        %>
        <td class="sort1">
            <a href="sort.do?&column=<%= column.getName() %>">
                <% if(column.isBusinessData()) {%>
                     <%= columnDisplayName %>
                <% } else { %>
                      <bean:message key="<%=MessagesHelper.COLUMN_DISPLAY_NAME_PREFIX+column.getName()%>" bundle="ProcessPortal"/>
                <% } %>
				<%
				String imageAltMessageKey="common.sortOrder.ASC.Full";
				if(column.getColumnSortOrder().equalsIgnoreCase("DESC"))
					imageAltMessageKey="common.sortOrder.DESC.Full";
				%>
                <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%= column.getColumnSortOrder() %>.gif' alt="<bean:message key="<%=imageAltMessageKey%>" bundle="ProcessPortal"/>" /></a>
        </td>
        <%
    } else if (column.isSecondSortColumn()) {
        %>
        <td class="sort2">
            <a href="sort.do?&column=<%= column.getName() %>">
                <% if(column.isBusinessData()) {%>
                     <%= columnDisplayName %>
                <% } else { %>
                      <bean:message key="<%=MessagesHelper.COLUMN_DISPLAY_NAME_PREFIX+column.getName()%>" bundle="ProcessPortal"/>
                <% } %>
				<%
				String imageAltMessageKey="common.sortOrder.ASC.Full";
				if(column.getColumnSortOrder().equalsIgnoreCase("DESC"))
					imageAltMessageKey="common.sortOrder.DESC.Full";
				%>
                <img src='<%= com.lombardisoftware.core.PortalSkinUtilities.getPortalSkinPath(request) %>/images/<%= column.getColumnSortOrder() %>.gif' alt="<bean:message key="<%=imageAltMessageKey%>" bundle="ProcessPortal"/>" /></a>
        </td>
        <%
    } else if (column.isBusinessData()) { // can't sort these
        %>
        <td>
            <a href="sort.do?&column=<%= ProcessSearchAPIDelegate.PROP_BUSINESS_DATA_PREFIX + column.getName() %>"> <%= columnDisplayName %> </a>
        </td>
        <%
    } else {
        %>
        <td>
            <a href="sort.do?&column=<%= column.getName() %>">
              <bean:message key="<%=MessagesHelper.COLUMN_DISPLAY_NAME_PREFIX+column.getName()%>" bundle="ProcessPortal"/>
            </a>
        </td>
        <%
    }
    ++rowNumber;
} %>
        <td><bean:message key="processDetails.TasksTable.Run" bundle="ProcessPortal"/></td>


    </tr>
</thead>
<tbody>
<%
List taskIds = new ArrayList(searchData.getResults().size());
for (java.util.Iterator it = searchData.getResults().iterator(); it.hasNext();) {
    Map row = (Map) it.next();
    Object taskId = row.get(ProcessSearchAPIDelegate.PROP_TASK_ID);
    taskIds.add(taskId);
}
Set assignableTasks = AuthorizationAPIDelegateFactory.getInstance().newInstance().canExecuteActionBulk(com.lombardisoftware.server.api.ActionPolicy.ACTION_ASSIGN_TASK, taskIds);

rowNumber = 1;
for (Iterator rows = searchData.getResults().iterator(); rows.hasNext();) {
    Map row = (Map) rows.next();
    Object instanceId = row.get(ProcessSearchAPIDelegate.PROP_INSTANCE_ID);
    Object taskId = row.get(ProcessSearchAPIDelegate.PROP_TASK_ID);
    String drillDownHref;
    if (instanceId == null) {
        drillDownHref = "/jsp/getTaskDetails.do?taskId=" + taskId;
    }
    else if (!queryObject.isOrganizedByInstance()) {
        drillDownHref = "/jsp/getProcessDetails.do?bpdInstanceId="+instanceId+"&taskId=" + taskId;
    } else {
        drillDownHref = "/jsp/getProcessDetails.do?bpdInstanceId=" + instanceId;
    }
%>
  <tr id="row<%= rowNumber %>">
    <td><label for="item<%= rowNumber %>"></label><input title='<bean:message key="<%= queryObject.isOrganizedByInstance()?\"advancedSearchResults.bpdInstancesTable.checkbox.title\":\"advancedSearchResults.tasksTable.checkbox.title\"%>" bundle="ProcessPortal"/>' type="checkbox" id="item<%= rowNumber %>" name="item<%= rowNumber %>" onClick="selectRow(<%= rowNumber %>);update<%= queryObject.isOrganizedByInstance()?"Instance":"Task" %>Checked(<%= queryObject.isOrganizedByInstance()?instanceId:taskId %>,this.checked);onSelectionChange();document.getElementById('item<%= rowNumber %>').focus();"></td>
<%
    int columnNumber = 1;
    for (ListIterator columns = queryObject.columnIterator(); columns.hasNext();) {
        Query.Column column = (Query.Column) columns.next();
        Object value = row.get(column.getSearchResultKey());

        boolean nullValue = value == null;
        boolean filtered = false;
        if (value == null) {
            value = MessagesHelper.getMessage(application, request, "advancedSearchResults.SearchResults.nullValue", "ProcessPortal");
        }
        if (value instanceof java.util.Calendar) {
            pageContext.setAttribute("columnValue", ((java.util.Calendar)value).getTime());
        } else {
        		String assignedToRoleColumnName = ProcessSearchAPIDelegate.PROP_ASSIGNED_TO_ROLE;
        		if (value instanceof java.lang.String && assignedToRoleColumnName.equals(column.getSearchResultKey())) {
                if (((String)value).length() <= 0) {
                    // Skip string operations on empty string if group name is empty.
                    value = MessagesHelper.getMessage(application, request, "advancedSearchResults.SearchResults.nullValue", "ProcessPortal");
                } else {
                    // Participant Names are in the form <PGName>_<'S'|'T'>_<PG-UUID>.<Snapshot-UUID>
                    // So we are just using the last two '_'s to pull the PG name
                    if (((String)value).matches(".*_[TS]_[\\da-f-]+\\.[\\da-f-]+")) {
                        String roleName = (String) value;
                        String displayName = roleName.substring(0, roleName.lastIndexOf("_"));
                        displayName = displayName.substring(0, displayName.lastIndexOf("_"));
                        value = displayName;
                    }
                }
            }
            if (value instanceof String && isUserInputEscaped) {
                value = StringEscapeUtilities.escapeHtml((String)value, true);
                filtered = true;
            }
            pageContext.setAttribute("columnValue", value);
        }
%>
    <td class="bidiText"><a href="<%= request.getContextPath() %><%= drillDownHref %> ">

          <% if (instanceStatusColumnNumber == columnNumber && !nullValue) {%>
                <bean:message key="<%=MessagesHelper.INSTANCE_STATUS_DISPLAY_NAME_PREFIX + value%>" bundle="ProcessPortal"/>
          <% } else if (priorityColumnNumber == columnNumber && !nullValue){
          %>
                <bean:message key="<%=MessagesHelper.PRIORITY_DISPLAY_NAME_PREFIX + value%>" bundle="ProcessPortal"/>
          <% }

          else if (value instanceof java.math.BigDecimal) {
                 if (((java.math.BigDecimal)value).scale() > 0) {
          %>
          		<%
                    if (decimalFormat == null) {
                        decimalFormat = NumberFormat.getNumberInstance(userPreference.getLocale());
                        decimalFormat.setMaximumFractionDigits(2);
                    }
          		%>
          		<%=decimalFormat.format(value)%>
                <%    } else { %>
          		<%
                    if (integerFormat == null)
                        integerFormat = NumberFormat.getIntegerInstance(userPreference.getLocale());
          		%>
          		<%=integerFormat.format(value)%>
          <% } } else if (value instanceof java.util.Date) { %>
          		<%
                    if (dateTimeFormat == null)
                        dateTimeFormat = BidiUtils.getDateTimeFormat(userPreference);
          		%>
          		<%=dateTimeFormat.format(value)%>
          <% } else {
                if (filtered) { %>
                    <bean:write name="columnValue" formatKey="" bundle="ProcessPortal" filter="false"/>
                <% } else { %>
                    <bean:write name="columnValue" formatKey="" bundle="ProcessPortal" filter="true"/>
                <% }
          } %>
        </a></td>
<%
       ++columnNumber;
    }

        %><td><%
         boolean infoPathForm = row.get(ProcessSearchAPIDelegate.PROP_TASK_ATTACHED_INFOPATH_FORM_REF) != null;
         boolean externalActivity = row.get(ProcessSearchAPIDelegate.PROP_TASK_ATTACHED_EXTERNAL_ACTIVITY_REF) != null;
         if (TaskInstanceUtils.isTaskRunnable(row, user)) {
                 if(infoPathForm) {%>
                      <img src="<%= processPortalSupportContextRoot %>/jsp/images/run_disabled.gif" alt='<bean:message key="processDetails.TasksTable.tip.RunTaskInfoPath" bundle="ProcessPortal"/>'/>
                 <% } else if(externalActivity) { %>
                      &nbsp;&nbsp;&nbsp;
                 <% } else { %>
                <a href="#" title='<bean:message key="processDetails.TasksTable.tip.RunTask" bundle="ProcessPortal"/>' onClick="performPopupActionSingleWindowAndDisable(this, 'teamworksruntask<%=taskId%>', '<%= teamworksContextRoot %>/process.lsw?zWorkflowState=1', 'zTaskId=<%=taskId%>', 'height=600,width=720,scrollbars=yes,resizable=yes');">
                 <img src="<%= processPortalSupportContextRoot%>/jsp/images/run.gif" alt="<bean:message key="scoreboard.MyTaskList.run" bundle="ProcessPortal"/>" />
                </a>
        <% }
          } else if(TaskInstanceUtils.isTaskRunnableByStatus(row)) {
              if (assignableTasks.contains(taskId)) {
                  if(infoPathForm) {%>
                       <img src="<%= processPortalSupportContextRoot %>/jsp/images/run_disabled.gif" alt='<bean:message key="processDetails.TasksTable.tip.RunTaskInfoPath" bundle="ProcessPortal"/>'/>
                   <% } else if(externalActivity) { %>
                       &nbsp;&nbsp;&nbsp;
                   <% } else if(userPreference.isAlertOnAssignAndRun()){%>
                   <a href="#" title='<bean:message key="processDetails.TasksTable.tip.AssignAndRunTask" bundle="ProcessPortal"/>' onClick="performPopupActionWithWarningSingleWindow('teamworksruntask<%=taskId%>', 'processDetails/assignTask.do?needToRun=true', 'id=<%=taskId%>', 'height=600,width=720,scrollbars=yes,resizable=yes','<bean:message key="assignAndRunConfirmation.MessageBody" bundle="ProcessPortal" encodeTo="inlinejs"/>')">
                   <img src="<%= processPortalSupportContextRoot %>/jsp/images/run.gif" alt="<bean:message key="scoreboard.MyTaskList.run" bundle="ProcessPortal"/>" />
                   </a>
                  <% }else { %>
                    <a href="#" title='<bean:message key="processDetails.TasksTable.tip.AssignAndRunTask" bundle="ProcessPortal"/>' onClick="performPopupActionSingleWindowAndDisable(this, 'teamworksruntask<%=taskId%>', 'processDetails/assignTask.do?needToRun=true', 'id=<%=taskId%>', 'height=600,width=720,scrollbars=yes,resizable=yes')">
                    <img src="<%= processPortalSupportContextRoot %>/jsp/images/run.gif" alt="<bean:message key="scoreboard.MyTaskList.run" bundle="ProcessPortal"/>"/>
                    </a>
                  <% }
              } else {
                  %>&nbsp;&nbsp;&nbsp;<%
              }
           } else {
               %>&nbsp;&nbsp;&nbsp;<%
           }
        %>
    </td>

  </tr>
<%
++rowNumber;
}
%>
</tbody>
</table>

<div class="content-table-pagination">
    <% if (searchData.getTotalPages() > 1) { %>
    Page
    <%  for (int i = 0; i < searchData.getTotalPages(); i++) {
      if( (i+1) != searchData.getActivePageIndex()) {%>
       <a href="getSavedSearch.do?startsWith=<%= searchData.getMaxItemsOnPage() * i %>"><%=i+1%> </a>
      <% } else { %>
       <%=i+1%>
    <%   }
         }
      } %>
</div>

<%
if (time >= 0L) {
    NumberFormat countFormat = NumberFormat.getIntegerInstance(userPreference.getLocale());
    NumberFormat durationFormat = NumberFormat.getNumberInstance(userPreference.getLocale());
    durationFormat.setMaximumFractionDigits(2);
    durationFormat.setMinimumFractionDigits(2);

    int count = searchData.getTotalCount();
    double timeSeconds = (double)time / 1000D;

    String countDisplayValue = countFormat.format(count);
    String timeDisplayValue = durationFormat.format(timeSeconds);

    MessageFormat format = new MessageFormat(MessagesHelper.getMessage(
        application, request, "advancedSearchResults.searchStats.message", "ProcessPortal"));
%>
<div class="searchstats">
<%= format.format(new Object[]{countDisplayValue, timeDisplayValue}) %>
</div>
<%
} %>

<script type="text/javascript">
    onSelectionChange();
</script>
