<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="java.util.*" %>
<%@ page import="com.lombardisoftware.core.UserPreference"%>
<%@ page import="com.lombardisoftware.portal.utils.UserAttributesHelper"%>
<%@ page import="com.lombardisoftware.portal.utils.BidiUtils"%>

<%@ taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@ taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<%@ taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>

<%
	UserPreference userPreference = (UserPreference)session.getAttribute(UserPreference.SESSION_KEY);
	Map<String, String> attrData = UserAttributesHelper.getUserAttributes();
%>

<style type="text/css">

    #dueContainer {
        margin-top: 2em;
    }

    #dueButtons {
        margin-bottom: 2px;
        padding: 1px
    }

    #time {
        margin-top: 10px;
        font-size: 130%;
    }

    #due {
        border: none;
        font-weight: bold;
    }
</style>

<script type="text/javascript">
    dojo.require("dijit.Calendar");
    dojo.require("dijit.form.TimeTextBox");
    dojo.require("dojo.date.locale");
	<%=BidiUtils.getDojoCalendarRequireStatement(userPreference)%>

    /**
     * Glues full date from Calendar date and TimeTextBox time.
     */
    function getDateTime() {
        var date = dijit.byId("date").attr("value");
        var time = dijit.byId("time").attr("value");
        date.setSeconds(0);
        date.setMilliseconds(0);
        // Due to bug with Hebrew calendar implementation, time part must be set this way
        date.setMinutes(time.getMinutes() + time.getHours()*60);
        return date;
    }

    /**
     * Formats date with
     */
    function formatDate() {
        dojo.byId("due").value = <%=BidiUtils.getDojoDatePackage(attrData)%>.locale.format(getDateTime());
    }

    dojo.addOnLoad(function(){
        // Date is unimportant. Setting time to 00:00.
        dijit.byId("date").attr("value", new Date());
        dijit.byId("time").attr("value", new Date(2010, 01, 01, 0, 0));
        dijit.byId("time").onChange=function(){ formatDate() };
        dijit.byId("date").onChange=function(){ formatDate() };
        formatDate();

        dojo.connect(dojo.byId("ok"), "onclick", "validateDueDate");
        dojo.connect(dojo.byId("cancel"), "onclick", function(e) {
            e.preventDefault();
            self.close();
        });
    });

</script>


<div id="body" class="soria">
    <form name="changeDueDateForm" >
        <div class="body">
			<!-- due to a bug with hebrew calendar, a calendar widget must always be initialized with a value -->
            <div id="date" dojoType="dijit.Calendar" datePackage = <%=BidiUtils.getDojoDatePackage(attrData)%> value="2000-01-01"></div>
            <br/>
            <div id="time" dojoType="dijit.form.TimeTextBox"></div>

            <div id="dueContainer">
                <label for="due"><bean:message key="changeDueDate.NewDateAndTime" bundle="ProcessPortal"/><bean:message key="reports.adhoc.SingleColon" bundle="ProcessPortal"/></label>
                <input type="Text" size="20" id="due" name="due" value ="" readonly/>
            </div>
            <br/><!-- 
            <div>
                <input type="checkbox" id="forceCheckbox"/>
                <label for="forceCheckbox"><bean:message key="changeDueDate.ForceCheckboxLabel" bundle="ProcessPortal" encodeTo="none"/></label>
            </div>
            <br/> -->
            <div id="dueButtons">
                <button id="ok" type="button"><bean:message key="common.buttonOk" bundle="ProcessPortal"/></button>
                <button id="cancel" type="button"><bean:message key="common.buttonCancel" bundle="ProcessPortal"/></button>
            </div>
            <logic:messagesPresent>
                <div>
                    <html:messages id="msg" header="errors.header" footer="errors.footer" bundle="ProcessPortal">
                        <li><bean:write name="msg" bundle="ProcessPortal" filter="false"/></li>
                    </html:messages>
                </div>
            </logic:messagesPresent>
        </div>
    </form>

</div>
